<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.goodsorder_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/sing_goods/goodsorder";
  import {mapGetters} from "vuex";

  export default {
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          selection: true,
          dialogClickModal: false,
          column: [
            {
              label: "用户名",
              prop: "userName",
              editDisabled: true,
              search: true,
              rules: [{
                required: true,
                message: "请输入用户",
                trigger: "blur"
              }]
            },
            {
              label: "商品名",
              prop: "goodsName",
              editDisabled: true,
              search: true,
              rules: [{
                required: true,
                message: "请输入商品名",
                trigger: "blur"
              }]
            },
            {
              label: "商品图片",
              prop: "goodsImgUrl",
              type: 'upload',
              listType: 'picture-img',
              dataType: 'string',
              span: 12,
              propsHttp: {
                res: 'data',
                url: 'link'
              },
              action: '/api/blade-resource/oss/endpoint/put-file',
              rules: [{
                required: true,
                message: "请输入商品图片",
                trigger: "blur"
              }]
            },
            {
              label: "电话",
              prop: "phone",
              search: true,
              rules: [{
                required: true,
                message: "请输入电话",
                trigger: "blur"
              }]
            },
            {
              label: "商品价格",
              prop: "goodsPoint",
              rules: [{
                required: true,
                message: "请输入商品价格",
                trigger: "blur"
              }]
            },
            {
              label: "兑换数量",
              prop: "num",
              rules: [{
                required: true,
                message: "请输入兑换数量",
                trigger: "blur"
              }]
            },
            {
              label: "类型",
              prop: "type",
              rules: [{
                required: true,
                message: "请输入类型",
                trigger: "blur"
              }]
            },
            {
              label: "商品状态",
              prop: "goodsStatus",
              rules: [{
                required: true,
                message: "请输入商品状态",
                trigger: "blur"
              }]
            },
            {
              label: "物流单号",
              prop: "trackingNumber",
              rules: [{
                required: true,
                message: "请输入物流单号",
                trigger: "blur"
              }]
            },
            {
              label: "物流公司",
              prop: "trackingName",
              rules: [{
                required: true,
                message: "请输入物流公司",
                trigger: "blur"
              }]
            },
            {
              label: "物流公司编号",
              prop: "shipperCode",
              rules: [{
                required: true,
                message: "请输入物流公司编号",
                trigger: "blur"
              }]
            },
            {
              label: "使用积分",
              prop: "usePoint",
              rules: [{
                required: true,
                message: "请输入使用积分",
                trigger: "blur"
              }]
            },
            {
              label: "现金",
              prop: "cash",
              rules: [{
                required: true,
                message: "请输入现金",
                trigger: "blur"
              }]
            },
            {
              label: "地址",
              prop: "address",
              rules: [{
                required: true,
                message: "请输入地址",
                trigger: "blur"
              }]
            },
            {
              label: "收货人",
              prop: "consignee",
              rules: [{
                required: true,
                message: "请输入收货人",
                trigger: "blur"
              }]
            },
            // {
            //   label: "商品名",
            //   prop: "goodsName",
            //   rules: [{
            //     required: true,
            //     message: "请输入商品名",
            //     trigger: "blur"
            //   }]
            // },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.goodsorder_add, false),
          viewBtn: this.vaildData(this.permission.goodsorder_view, false),
          delBtn: this.vaildData(this.permission.goodsorder_delete, false),
          editBtn: this.vaildData(this.permission.goodsorder_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
